<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: io/writelog_pid.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_7dc76e12c3f74bb85b7effb3b7dc07e4.html">io</a>
  </div>
</div>
<div class="contents">
<h1>writelog_pid.c</h1><a href="writelog__pid_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: writelog_pid.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">magpario.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field/field.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/addons.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#endif</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 <span class="preprocessor">#ifdef SUNDIALS_VERSION</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg/llg.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#endif</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="keyword">static</span> <span class="keywordtype">int</span>     doinit=1;
<a name="l00040"></a>00040 <span class="keyword">static</span> <span class="keywordtype">int</span>     fieldon=0;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">static</span> FILE    **logfile; 
<a name="l00043"></a>00043 <span class="keyword">static</span> Vec     Mpid,Mbak;
<a name="l00044"></a>00044 <span class="keyword">static</span> Vec     Hpid;
<a name="l00045"></a>00045 <span class="keyword">static</span> Vec     Xcomp;
<a name="l00046"></a>00046 <span class="keyword">static</span> Vec     *maskpidvol;
<a name="l00047"></a>00047 <span class="keyword">static</span> Vec     *maskpidone;
<a name="l00048"></a>00048 <span class="keyword">static</span> PetscReal *volpid;
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="writelog__pid_8c.html#afead37ceb35d036cf38fc7a8ebe4805f">00050</a> <span class="keywordtype">int</span> <a class="code" href="writelog__pid_8c.html#afead37ceb35d036cf38fc7a8ebe4805f">WriteLogPidInit</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="keywordtype">int</span> rank,size;
<a name="l00055"></a>00055   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00056"></a>00056   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   PetscTruth flg;
<a name="l00059"></a>00059   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-logpid&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;fieldon,&amp;flg);CHKERRQ(ierr);
<a name="l00060"></a>00060   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00061"></a>00061     fieldon=0;
<a name="l00062"></a>00062     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00063"></a>00063       <span class="stringliteral">&quot;Option -logpid not found, using default value: %i\n&quot;</span>,
<a name="l00064"></a>00064       fieldon
<a name="l00065"></a>00065     );
<a name="l00066"></a>00066   }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>==1) {
<a name="l00069"></a>00069     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Only %i pid found\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>);
<a name="l00070"></a>00070     fieldon=0;
<a name="l00071"></a>00071   }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00074"></a>00074     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Not storing *.log_pid files\n&quot;</span>);
<a name="l00075"></a>00075     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00076"></a>00076   }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Creating *.log_pid files\n&quot;</span>);
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;Mpid);CHKERRQ(ierr);
<a name="l00081"></a>00081   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;Mbak);CHKERRQ(ierr);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;Hpid);CHKERRQ(ierr);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   ierr = VecCreate(PETSC_COMM_WORLD,&amp;Xcomp);CHKERRQ(ierr);
<a name="l00086"></a>00086   ierr = VecSetSizes(Xcomp,gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);CHKERRQ(ierr);
<a name="l00087"></a>00087   ierr = VecSetFromOptions(Xcomp);CHKERRQ(ierr);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<span class="keyword">sizeof</span>(FILE*),&amp;logfile);CHKERRQ(ierr);
<a name="l00090"></a>00090   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<span class="keyword">sizeof</span>(Vec),&amp;maskpidvol);CHKERRQ(ierr);
<a name="l00091"></a>00091   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++) {
<a name="l00092"></a>00092     ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;maskpidvol[i]);CHKERRQ(ierr);
<a name="l00093"></a>00093   }
<a name="l00094"></a>00094   PetscReal *ta_evol,*ta_vvol;
<a name="l00095"></a>00095   VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;ta_evol);
<a name="l00096"></a>00096   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>;i++) {
<a name="l00097"></a>00097     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> l=0;l&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;l++) {
<a name="l00098"></a>00098       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;k++) {
<a name="l00099"></a>00099         ierr = VecSetValue(
<a name="l00100"></a>00100           maskpidvol[gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]],
<a name="l00101"></a>00101           ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+l]+k,
<a name="l00102"></a>00102           ta_evol[i]/NV,
<a name="l00103"></a>00103           ADD_VALUES
<a name="l00104"></a>00104         );CHKERRQ(ierr);
<a name="l00105"></a>00105        }
<a name="l00106"></a>00106     }
<a name="l00107"></a>00107   }
<a name="l00108"></a>00108   VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;ta_evol);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;volpid);CHKERRQ(ierr);
<a name="l00111"></a>00111   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++) {
<a name="l00112"></a>00112     ierr = VecAssemblyBegin(maskpidvol[i]);CHKERRQ(ierr);
<a name="l00113"></a>00113     ierr = VecAssemblyEnd(maskpidvol[i]);CHKERRQ(ierr);
<a name="l00114"></a>00114     <span class="comment">/* can use NORM_1 because all volumes are positive */</span>
<a name="l00115"></a>00115     VecStrideNorm(maskpidvol[i],0,NORM_1,&amp;volpid[i]);
<a name="l00116"></a>00116     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;pid: %i  volume: %g\n&quot;</span>,i,volpid[i]);
<a name="l00117"></a>00117   }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<span class="keyword">sizeof</span>(Vec),&amp;maskpidone);CHKERRQ(ierr);
<a name="l00120"></a>00120   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++) {
<a name="l00121"></a>00121     PetscReal *ta_mpv;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123     ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;maskpidone[i]);CHKERRQ(ierr);
<a name="l00124"></a>00124     ierr = VecCopy(maskpidvol[i],maskpidone[i]);CHKERRQ(ierr);
<a name="l00125"></a>00125     VecGetArray(maskpidone[i],&amp;ta_mpv);
<a name="l00126"></a>00126     VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>,&amp;ta_vvol);
<a name="l00127"></a>00127     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;j++) {
<a name="l00128"></a>00128       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;k++) {
<a name="l00129"></a>00129         ta_mpv[ND*j+k]/=ta_vvol[j];
<a name="l00130"></a>00130       }
<a name="l00131"></a>00131     }
<a name="l00132"></a>00132     VecRestoreArray(maskpidone[i],&amp;ta_mpv);
<a name="l00133"></a>00133     VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>,&amp;ta_vvol);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="comment">/*</span>
<a name="l00136"></a>00136 <span class="comment">    PetscReal v;</span>
<a name="l00137"></a>00137 <span class="comment">    VecStrideNorm(maskpidone[i],0,NORM_1,&amp;v);</span>
<a name="l00138"></a>00138 <span class="comment">    PetscPrintf(PETSC_COMM_WORLD,&quot;pid: %i  one: %g\n&quot;,i,v);</span>
<a name="l00139"></a>00139 <span class="comment">*/</span>
<a name="l00140"></a>00140   }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="keywordflow">if</span> (rank) {
<a name="l00143"></a>00143     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00144"></a>00144   }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++) {
<a name="l00147"></a>00147     <span class="comment">/* skip if volume is zero */</span>
<a name="l00148"></a>00148     <span class="keywordflow">if</span> (volpid[i]&lt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00149"></a>00149       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;volume of pid: %i is zero, skipping output\n&quot;</span>,i);
<a name="l00150"></a>00150       <span class="keywordflow">continue</span>;
<a name="l00151"></a>00151     }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153     <span class="keywordtype">char</span> fmesh[256];
<a name="l00154"></a>00154     ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s%s%03i&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,<span class="stringliteral">&quot;.log_&quot;</span>,i+1);CHKERRQ(ierr);
<a name="l00155"></a>00155     ierr = PetscFOpen(PETSC_COMM_WORLD,fmesh,<span class="stringliteral">&quot;a&quot;</span>,&amp;logfile[i]);CHKERRQ(ierr);
<a name="l00156"></a>00156     <span class="keywordflow">if</span> (!logfile[i]) {
<a name="l00157"></a>00157       SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,fmesh);
<a name="l00158"></a>00158     }
<a name="l00159"></a>00159     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,fmesh);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     PetscGetDate(fmesh,255);
<a name="l00162"></a>00162     ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile[i],<span class="stringliteral">&quot;#.date: %s\n&quot;</span>,fmesh);
<a name="l00163"></a>00163     ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile[i],<span class="stringliteral">&quot;#.volume_with_pid:%i\n&quot;</span>,i+1);
<a name="l00164"></a>00164     ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile[i],<span class="stringliteral">&quot;#.volume:%g\n&quot;</span>,volpid[i]);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166     <span class="comment">/*      1    2    3    4    5    6    7    8    9   10   11   12   13 */</span>
<a name="l00167"></a>00167     ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile[i],
<a name="l00168"></a>00168       <span class="stringliteral">&quot;#.%14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s\n&quot;</span>,
<a name="l00169"></a>00169       <span class="stringliteral">&quot;............1:&quot;</span>,
<a name="l00170"></a>00170       <span class="stringliteral">&quot; 2:&quot;</span>,
<a name="l00171"></a>00171       <span class="stringliteral">&quot; 3:&quot;</span>,
<a name="l00172"></a>00172       <span class="stringliteral">&quot; 4:&quot;</span>,
<a name="l00173"></a>00173       <span class="stringliteral">&quot; 5:&quot;</span>,
<a name="l00174"></a>00174       <span class="stringliteral">&quot; 6:&quot;</span>,
<a name="l00175"></a>00175       <span class="stringliteral">&quot; 7:&quot;</span>,
<a name="l00176"></a>00176       <span class="stringliteral">&quot; 8:&quot;</span>,
<a name="l00177"></a>00177       <span class="stringliteral">&quot; 9:&quot;</span>,
<a name="l00178"></a>00178       <span class="stringliteral">&quot;10:&quot;</span>,
<a name="l00179"></a>00179       <span class="stringliteral">&quot;11:&quot;</span>,
<a name="l00180"></a>00180       <span class="stringliteral">&quot;12:&quot;</span>,
<a name="l00181"></a>00181       <span class="stringliteral">&quot;13:&quot;</span>
<a name="l00182"></a>00182     );CHKERRQ(ierr);
<a name="l00183"></a>00183     <span class="comment">/*      1    2    3    4    5    6    7    8    9   10   11   12   13 */</span>
<a name="l00184"></a>00184     ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile[i],
<a name="l00185"></a>00185       <span class="stringliteral">&quot;#.%14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s\n&quot;</span>,
<a name="l00186"></a>00186       <span class="stringliteral">&quot;..........time&quot;</span>,
<a name="l00187"></a>00187       <span class="stringliteral">&quot;Etot&quot;</span>,
<a name="l00188"></a>00188       <span class="stringliteral">&quot;Mavg_x&quot;</span>,
<a name="l00189"></a>00189       <span class="stringliteral">&quot;Mavg_y&quot;</span>,
<a name="l00190"></a>00190       <span class="stringliteral">&quot;Mavg_z&quot;</span>,
<a name="l00191"></a>00191       <span class="stringliteral">&quot;|Mavg|&quot;</span>,
<a name="l00192"></a>00192       <span class="stringliteral">&quot;Havg_x&quot;</span>,
<a name="l00193"></a>00193       <span class="stringliteral">&quot;Havg_y&quot;</span>,
<a name="l00194"></a>00194       <span class="stringliteral">&quot;Havg_z&quot;</span>,
<a name="l00195"></a>00195       <span class="stringliteral">&quot;Edem&quot;</span>,
<a name="l00196"></a>00196 #ifdef EXCH
<a name="l00197"></a>00197       <span class="stringliteral">&quot;Eanionly&quot;</span>,
<a name="l00198"></a>00198 #<span class="keywordflow">else</span>
<a name="l00199"></a>00199       <span class="stringliteral">&quot;Eexchani&quot;</span>,
<a name="l00200"></a>00200 #endif
<a name="l00201"></a>00201       <span class="stringliteral">&quot;Eext&quot;</span>,
<a name="l00202"></a>00202 #ifdef EXCH
<a name="l00203"></a>00203       <span class="stringliteral">&quot;Eexchonly&quot;</span>
<a name="l00204"></a>00204 #<span class="keywordflow">else</span>
<a name="l00205"></a>00205        <span class="stringliteral">&quot;-&quot;</span>
<a name="l00206"></a>00206 #endif
<a name="l00207"></a>00207     );CHKERRQ(ierr);
<a name="l00208"></a>00208     <span class="comment">/*      1    2    3    4    5    6    7    8    9   10 */</span>
<a name="l00209"></a>00209     ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile[i],
<a name="l00210"></a>00210       <span class="stringliteral">&quot;#.%14s %14s %14s %14s %14s %14s %14s %14s %14s %14s\n&quot;</span>,
<a name="l00211"></a>00211       <span class="comment">/* &quot;time&quot;,      */</span> <span class="stringliteral">&quot;..........(ns)&quot;</span>,
<a name="l00212"></a>00212       <span class="comment">/* &quot;Etot&quot;,      */</span> <span class="stringliteral">&quot;(J/m^3)&quot;</span>,
<a name="l00213"></a>00213       <span class="comment">/* &quot;Mavg_x&quot;,    */</span> <span class="stringliteral">&quot;(1)&quot;</span>,
<a name="l00214"></a>00214       <span class="comment">/* &quot;Mavg_y&quot;,    */</span> <span class="stringliteral">&quot;(1)&quot;</span>,
<a name="l00215"></a>00215       <span class="comment">/* &quot;Mavg_z&quot;,    */</span> <span class="stringliteral">&quot;(1)&quot;</span>,
<a name="l00216"></a>00216       <span class="comment">/* &quot;|Mavg|&quot;,    */</span> <span class="stringliteral">&quot;(1)&quot;</span>,
<a name="l00217"></a>00217       <span class="comment">/* &quot;Havg_x&quot;,    */</span> <span class="stringliteral">&quot;(T)&quot;</span>,
<a name="l00218"></a>00218       <span class="comment">/* &quot;Havg_y&quot;,    */</span> <span class="stringliteral">&quot;(T)&quot;</span>,
<a name="l00219"></a>00219       <span class="comment">/* &quot;Havg_z&quot;,    */</span> <span class="stringliteral">&quot;(T)&quot;</span>,
<a name="l00220"></a>00220       <span class="comment">/* &quot;Edem&quot;,      */</span> <span class="stringliteral">&quot;(J/m^3)&quot;</span>,
<a name="l00221"></a>00221       <span class="comment">/* &quot;Eexchani&quot;,  */</span> <span class="stringliteral">&quot;(J/m^3)&quot;</span>,
<a name="l00222"></a>00222       <span class="comment">/* &quot;Eext&quot;,      */</span> <span class="stringliteral">&quot;(J/m^3)&quot;</span>,
<a name="l00223"></a>00223 #ifdef EXCH
<a name="l00224"></a>00224       <span class="comment">/* &quot;Eexchonly&quot;, */</span> <span class="stringliteral">&quot;(J/m^3)&quot;</span>
<a name="l00225"></a>00225 #<span class="keywordflow">else</span>
<a name="l00226"></a>00226       <span class="comment">/* &quot;void&quot;,      */</span> <span class="stringliteral">&quot;-&quot;</span>
<a name="l00227"></a>00227 #endif
<a name="l00228"></a>00228     );CHKERRQ(ierr);
<a name="l00229"></a>00229   }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00232"></a>00232 }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a><a class="code" href="writelog__pid_8c.html#aa63307197e81d27990850ea179eb5187">00235</a> <span class="keywordtype">int</span> <a class="code" href="magpario_8h.html#aa63307197e81d27990850ea179eb5187">WriteLogPid</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00236"></a>00236 {
<a name="l00237"></a>00237   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   <span class="keywordtype">int</span> rank,size;
<a name="l00240"></a>00240   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00241"></a>00241   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   <span class="keywordflow">if</span> (doinit) {
<a name="l00244"></a>00244     ierr = <a class="code" href="writelog__pid_8c.html#afead37ceb35d036cf38fc7a8ebe4805f">WriteLogPidInit</a>(gdata);CHKERRQ(ierr);
<a name="l00245"></a>00245     doinit=0;
<a name="l00246"></a>00246   }
<a name="l00247"></a>00247   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00248"></a>00248     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00249"></a>00249   }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   VecCopy(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,Mbak);
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++) {
<a name="l00254"></a>00254     <span class="comment">/* skip if volume is zero */</span>
<a name="l00255"></a>00255     <span class="keywordflow">if</span> (volpid[i]&lt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) <span class="keywordflow">continue</span>;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257     ierr = VecPointwiseMult(Mpid,Mbak,maskpidvol[i]);CHKERRQ(ierr);
<a name="l00258"></a>00258 
<a name="l00259"></a>00259     <span class="comment">/* calculate Mavg (ignoring Js) */</span>
<a name="l00260"></a>00260     PetscReal Mavg[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00261"></a>00261     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;j++) {
<a name="l00262"></a>00262       <span class="comment">/* cannot use VecStrideNorm with NORM_1 because values are pos. and neg.! */</span>
<a name="l00263"></a>00263       ierr = VecStrideGather(Mpid,j,Xcomp,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00264"></a>00264       ierr = VecSum(Xcomp,&amp;Mavg[j]);CHKERRQ(ierr);
<a name="l00265"></a>00265     }
<a name="l00266"></a>00266     <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(ND,1.0/volpid[i],Mavg,1);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268     ierr = VecPointwiseMult(Hpid,gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,maskpidvol[i]);CHKERRQ(ierr);
<a name="l00269"></a>00269 
<a name="l00270"></a>00270     <span class="comment">/* calculate Havg */</span>
<a name="l00271"></a>00271     PetscReal Havg[ND];
<a name="l00272"></a>00272     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;ND;j++) {
<a name="l00273"></a>00273       ierr = VecStrideGather(Hpid,j,Xcomp,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00274"></a>00274       ierr = VecSum(Xcomp,&amp;Havg[j]);CHKERRQ(ierr);
<a name="l00275"></a>00275     }
<a name="l00276"></a>00276     <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(ND,1.0/volpid[i],Havg,1);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278     ierr = VecPointwiseMult(Mpid,Mbak,maskpidone[i]);CHKERRQ(ierr);
<a name="l00279"></a>00279     VecCopy(Mpid,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);
<a name="l00280"></a>00280     <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 <span class="comment">/*          1    2    3    4    5    6    7    8    9   10   11   12   13 */</span>
<a name="l00283"></a>00283     ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile[i],
<a name="l00284"></a>00284       <span class="stringliteral">&quot;  %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e\n&quot;</span>,
<a name="l00285"></a>00285       <span class="comment">/* &quot;time&quot;,      &quot;(ns)&quot;,    */</span> gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9,
<a name="l00286"></a>00286       <span class="comment">/* &quot;Etot&quot;,      &quot;(J/m^3)&quot;, */</span> gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>*gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>/volpid[i],
<a name="l00287"></a>00287       <span class="comment">/* &quot;Mavg_x&quot;,    &quot;(1)&quot;,     */</span> Mavg[0],
<a name="l00288"></a>00288       <span class="comment">/* &quot;Mavg_y&quot;,    &quot;(1)&quot;,     */</span> Mavg[1],
<a name="l00289"></a>00289       <span class="comment">/* &quot;Mavg_z&quot;,    &quot;(1)&quot;,     */</span> Mavg[2],
<a name="l00290"></a>00290       <span class="comment">/* &quot;|Mavg|&quot;,    &quot;(1)&quot;,     */</span> sqrt(Mavg[0]*Mavg[0]+Mavg[1]*Mavg[1]+Mavg[2]*Mavg[2]),
<a name="l00291"></a>00291       <span class="comment">/* &quot;Havg_x&quot;,    &quot;(1)&quot;,     */</span> Havg[0],
<a name="l00292"></a>00292       <span class="comment">/* &quot;Havg_y&quot;,    &quot;(1)&quot;,     */</span> Havg[1],
<a name="l00293"></a>00293       <span class="comment">/* &quot;Havg_z&quot;,    &quot;(1)&quot;,     */</span> Havg[2],
<a name="l00294"></a>00294       <span class="comment">/* &quot;Edem&quot;,      &quot;(J/m^3)&quot;, */</span> gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>*gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>/volpid[i],
<a name="l00295"></a>00295 #ifdef EXCH
<a name="l00296"></a>00296       <span class="comment">/* &quot;Eanionly&quot;,  &quot;(J/m^3)&quot;, */</span> (gdata-&gt;<a class="code" href="structGridData.html#accc6d5863bfdcbf0dde4e412350729b1">Eexchani</a>-gdata-&gt;Eexchonly)*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>*gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>/volpid[i],
<a name="l00297"></a>00297 #<span class="keywordflow">else</span>
<a name="l00298"></a>00298       <span class="comment">/* &quot;Eexchani&quot;,  &quot;(J/m^3)&quot;, */</span> gdata-&gt;<a class="code" href="structGridData.html#accc6d5863bfdcbf0dde4e412350729b1">Eexchani</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>*gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>/volpid[i],
<a name="l00299"></a>00299 #endif
<a name="l00300"></a>00300       <span class="comment">/* &quot;Eext&quot;,      &quot;(J/m^3)&quot;, */</span> gdata-&gt;<a class="code" href="structGridData.html#a17b4a3f0a4fcf4832fe0004f242a4ecb">Eext</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>*gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>/volpid[i],
<a name="l00301"></a>00301 #ifdef EXCH
<a name="l00302"></a>00302       <span class="comment">/* &quot;Eexchonly&quot;, &quot;(J/m^3)&quot;, */</span> gdata-&gt;Eexchonly*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>*gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>/volpid[i]
<a name="l00303"></a>00303 #<span class="keywordflow">else</span>
<a name="l00304"></a>00304       <span class="comment">/* &quot;void&quot;,      &quot;&quot;,        */</span> -1.0
<a name="l00305"></a>00305 #endif
<a name="l00306"></a>00306     );
<a name="l00307"></a>00307   }
<a name="l00308"></a>00308 
<a name="l00309"></a>00309   <span class="comment">/* recalculate energy with correct M (otherwise wrong results at end of simulation) */</span>
<a name="l00310"></a>00310   VecCopy(Mbak,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);
<a name="l00311"></a>00311   <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00314"></a>00314 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

